# Makefile for GNU C NATIVE COMPILER for the atariST/TT series hosted
#  on a Sparc host (tested only on Sun)S 4.0.3)
#  NOTE: requires alloca.c from the emacs dist.
#

# Makefile for GNU C compiler.
#   Copyright (C) 1987 Free Software Foundation, Inc.

#This file is part of GNU CC.

#GNU CC is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY.  No author or distributor
#accepts responsibility to anyone for the consequences of using it
#or for whether it serves any particular purpose or works at all,
#unless he says so in writing.  Refer to the GNU CC General Public
#License for full details.

#Everyone is granted permission to copy, modify and redistribute
#GNU CC, but only under the conditions described in the
#GNU CC General Public License.   A copy of this license is
#supposed to have been given to you along with GNU CC so you
#can know your rights and responsibilities.  It should be in a
#file named COPYING.  Among other things, the copyright notice
#and this notice must be preserved on all copies.

.NOEXPORT: # This tells GNU Make version 3
	   # not to put all the variables in the environment.


CROSSDIR = /net/acae127/home/bammi/atari/cross-gcc
CROSSBIN = $(CROSSDIR)/bin
CROSSLIB = $(CROSSDIR)/lib
CROSSINC = $(CROSSDIR)/include

# BASEREL not yet supported. Howard has sent some diffs for baserel
#         but they only work for gcc-cc1 and not gcc-cc1plus. since
#	  gcc-cc1plus shares most .o files with gcc-cc1, until that
#         is resolved, baserel is unsupported.
# BASEREL = -mbaserel -mpcrel

# ARCHFLAGS	if unset, the default is -m68000 that will work on all STs
#	        for the TT set -m68020 -m68881 for the falcon you probably
#		only want -m68020 unless you have the optional co-proc.
#
#		note: the above applies only when you have not changed the
#		TARGET_DEFAULT in tm-atari.h yourself. if you have changed
#		the default then adjust as appro.
# ARCHFLAGS = -m68020 -m68881

CC = $(CROSSBIN)/cgcc -pipe
DFLAGS = -DCROSSDIR=\"\"
CFLAGS = $(ARCHFLAGS) $(BASEREL) $(DFLAGS) -O2 -fomit-frame-pointer -I$(CROSSINC) -I./config -I. -Datarist=1
LDFLAGS =  $(ARCHFLAGS) $(BASEREL)

# hosts cc (give full path to gcc is hosts gcc is not before . in your PATH)
HOSTCC=gcc
HOSTCFLAGS = $(DFLAGS) -O -I./config -I.
# HOSTLDFLAGS =

# OLDCC should not be the GNU C compiler.
OLDCC = cc
BISON = bison
BISONFLAGS=
AR = ar
SHELL = /bin/sh

bindir = 
libdir = 

# These are what you would need on HPUX:
# CFLAGS = -Wc,-Ns2000 -Wc,-Ne700
# -g is desirable in CFLAGS, but a compiler bug in HPUX version 5
# bites whenever tree.def, rtl.def or machmode.def is included
# (ie., on every source file).
# CCLIBFLAGS = -Wc,-Ns2000 -Wc,-Ne700
# For CCLIBFLAGS you might want to specify the switch that
# forces only 68000 instructions to be used.

# If you are making gcc for the first time, and if you are compiling it with
# a non-gcc compiler, and if your system doesn't have a working alloca() in any
# of the standard libraries (as is true for HP/UX or Genix),
# then get alloca.c from GNU Emacs and un-comment the following line:
# ALLOCA = alloca.o

# If your system has alloca() in /lib/libPW.a, un-comment the following line:
# CLIB= -lPW
  
# If your system's malloc() routine fails for any reason (as it does on
# certain versions of Genix), try getting the files
# malloc.c and getpagesize.h from GNU Emacs and un-comment the following line:
# MALLOC = malloc.o

# If you are running GCC on an Apollo, you will need this:
# CFLAGS = -g -O -M 3000 -U__STDC__ -DSHORT_ENUM_BUG

# Change this to a null string if obstacks are installed in the
# system library.
OBSTACK=obstack.o
OBSTACK1=obstack.oo

# Dependency on obstack, alloca, malloc or whatever library facilities
# are not installed in the system libraries.
LIBDEPS= $(OBSTACK)
LIBDEPS1= $(OBSTACK1) $(HOSTALLOCA) $(MALLOC)

# How to link with both our special library facilities
# and the system's installed libraries.
LIBS = $(OBSTACK)
LIBS1 = $(OBSTACK1) $(HOSTALLOCA) $(MALLOC) $(MALLOC1) $(CLIB)

DIR = ../gcc

# Object files of CC1.
# Language-specific object files for C.
C_OBJS = c-parse.o c-lang.o c-lex.o c-pragma.o \
   c-decl.o c-typeck.o c-convert.o c-aux-info.o c-common.o c-iterate.o

# Language-specific object files for C++.
CPLUS_OBJS = cp-parse.o cp-decl.o cp-decl2.o \
   cp-typeck.o cp-type2.o cp-tree.o cp-ptree.o \
   cp-cvt.o cp-search.o cp-lex.o cp-gc.o cp-call.o \
   cp-class.o cp-init.o cp-method.o cp-except.o \
   cp-expr.o cp-pt.o cp-edsel.o cp-xref.o \
   $(CPLUS_INPUT) cp-spew.o c-common.o

# Language-independent object files.
OBJS = toplev.o version.o tree.o print-tree.o stor-layout.o fold-const.o \
 function.o stmt.o expr.o calls.o expmed.o explow.o optabs.o varasm.o \
 rtl.o print-rtl.o rtlanal.o emit-rtl.o real.o \
 dbxout.o sdbout.o dwarfout.o xcoffout.o \
 integrate.o jump.o cse.o loop.o unroll.o flow.o stupid.o combine.o \
 regclass.o local-alloc.o global.o reload.o reload1.o caller-save.o \
 insn-peep.o reorg.o sched.o final.o recog.o reg-stack.o \
 insn-opinit.o insn-recog.o insn-extract.o insn-output.o insn-emit.o \
 insn-attrtab.o aux-output.o getpwd.o convert.o $(EXTRA_OBJS)

GCC_PASSES=gcc cc1 cpp

# Files to be copied away after each stage in building.
STAGESTUFF = *.o insn-flags.h insn-config.h insn-codes.h \
 insn-output.c insn-recog.c insn-emit.c insn-extract.c insn-peep.c \
 insn-attr.h insn-attrtab.c insn-opinit.c \
 stamp-flags stamp-config stamp-codes \
 stamp-output stamp-recog stamp-emit stamp-extract stamp-peep \
 stamp-attr stamp-attrtab stamp-opinit stamp-proto \
 genemit genoutput genrecog genextract genflags gencodes genconfig genpeep \
 genattrtab genattr genopinit \
 $(GCC_PASSES) $(EXTRA_PARTS) $(EXTRA_PROGRAMS) gcc-cross cccp \
 cc1plus cc1obj enquire protoize unprotoize specs collect2 $(USE_COLLECT2)

# Header files that are made available to programs compiled with gcc.
USER_H = stddef.h stdarg.h assert.h va-*.h limits.h

# If you want to recompile everything, just do rm *.o.
# CONFIG_H = config.h tm.h
CONFIG_H =
RTL_H = rtl.h rtl.def machmode.h machmode.def
TREE_H = tree.h real.h tree.def machmode.h machmode.def
CPLUS_TREE_H = $(TREE_H) cp-tree.h cp-tree.def

ALL =  gcc.ttp gcc-cc1.ttp gcc-cpp.ttp

all : $(ALL)

compilations: ${OBJS}

gcc.ttp: gcc.o version.o $(LIBDEPS)
	$(CC) $(CFLAGS) $(LDFLAGS) -o gcc.ttp gcc.o version.o $(LIBS)

gcc.o: gcc.c $(CONFIG_H)
	$(CC) $(CFLAGS) -DDEFAULT_TARGET_MACHINE=\"atariST\" -c gcc.c

gcc-cc1.ttp: $(C_OBJS) $(OBJS) $(LIBDEPS)
	$(CC) $(CFLAGS) $(LDFLAGS) -o gcc-cc1.ttp $(C_OBJS) $(OBJS) $(LIBS)

gcc-cc1+.ttp: $(CPLUS_OBJS) $(OBJS) $(LIBDEPS)
	$(CC) $(CFLAGS) $(LDFLAGS) -o gcc-cc1+.ttp $(CPLUS_OBJS) $(OBJS) $(LIBS)

gcc-cc1o.ttp: $(OBJC_OBJS) $(OBJS) $(LIBDEPS)
	$(CC) $(CFLAGS) $(LDFLAGS) -o gcc-cc1o.ttp $(OBJC_OBJS) $(OBJS) $(LIBS)

# C-language specific files.

c-parse.o : c-parse.c $(CONFIG_H) $(TREE_H) c-lex.h c-tree.h input.h flags.h
	$(CC) $(CFLAGS) -c c-parse.c
c-parse.c c-parse.h: c-parse.y
	$(BISON) $(BISONFLAGS) -d c-parse.y -o c-parse.c

c-parse.y: c-parse.in 
	sed -e "/^ifobjc$$/,/^end ifobjc$$/d" \
	  -e "/^ifc$$/d" -e "/^end ifc$$/d" \
	  ./c-parse.in > ./c-parse.y

c-decl.o : c-decl.c $(CONFIG_H) $(TREE_H) c-tree.h c-lex.h flags.h
c-typeck.o : c-typeck.c $(CONFIG_H) $(TREE_H) c-tree.h flags.h
c-lang.o : c-lang.c $(CONFIG_H) $(TREE_H)
c-lex.o : c-lex.c $(CONFIG_H) $(TREE_H) c-lex.h c-tree.h c-parse.h \
    input.h flags.h
c-aux-info.o : c-aux-info.c  $(CONFIG_H) $(TREE_H) c-tree.h flags.h
c-convert.o : c-convert.c $(CONFIG_H) $(TREE_H) flags.h
c-iterate.o: c-iterate.c $(CONFIG_H) $(TREE_H) $(RTL_H) c-tree.h flags.h

# C++ language specific files.

cp-parse.o : cp-parse.c $(CONFIG_H) $(CPLUS_TREE_H) flags.h cp-lex.h
	$(CC) -c $(CFLAGS) cp-parse.c

cp-parse.c cp-parse.h : cp-parse.y
	@echo expect 29 shift/reduce conflicts and 14 reduce/reduce conflicts
	$(BISON) $(BISONFLAGS) -d -o cp-parse.c cp-parse.y
	grep '^#define[ 	]*YYEMPTY' cp-parse.c >>cp-parse.h

cp-spew.o : cp-spew.c $(CONFIG_H) $(CPLUS_TREE_H) \
   cp-parse.h flags.h
cp-lex.o : cp-lex.c $(CONFIG_H) $(CPLUS_TREE_H) \
   cp-parse.h cp-input.c flags.h
cp-decl.o : cp-decl.c $(CONFIG_H) $(CPLUS_TREE_H) flags.h \
  cp-lex.h cp-decl.h stack.h
cp-decl2.o : cp-decl2.c $(CONFIG_H) $(CPLUS_TREE_H) flags.h \
  cp-lex.h cp-decl.h
cp-type2.o : cp-type2.c $(CONFIG_H) $(CPLUS_TREE_H) flags.h
cp-typeck.o : cp-typeck.c $(CONFIG_H) $(CPLUS_TREE_H) flags.h
cp-class.o : cp-class.c $(CONFIG_H) $(CPLUS_TREE_H) stack.h \
    cp-class.h flags.h
cp-call.o : cp-call.c $(CONFIG_H) $(CPLUS_TREE_H) stack.h cp-class.h \
    flags.h
cp-init.o : cp-init.c $(CONFIG_H) $(CPLUS_TREE_H) flags.h
cp-method.o : cp-method.c $(CONFIG_H) $(CPLUS_TREE_H)
cp-cvt.o : cp-cvt.c $(CONFIG_H) $(CPLUS_TREE_H)
cp-search.o : cp-search.c $(CONFIG_H) $(CPLUS_TREE_H) stack.h flags.h
cp-tree.o : cp-tree.c $(CONFIG_H) $(CPLUS_TREE_H) flags.h
cp-ptree.o : cp-ptree.c $(CONFIG_H) $(CPLUS_TREE_H)
cp-gc.o : cp-gc.c $(CONFIG_H) $(CPLUS_TREE_H) flags.h
cp-except.o : cp-except.c $(CONFIG_H) $(CPLUS_TREE_H) flags.h
cp-expr.o : cp-expr.c $(CONFIG_H) $(CPLUS_TREE_H) $(RTL_H) flags.h \
  expr.h insn-codes.h
cp-edsel.o : cp-edsel.c $(CONFIG_H) $(CPLUS_TREE_H) stack.h flags.h
cp-xref.o : cp-xref.c $(CONFIG_H) $(CPLUS_TREE_H)
cp-pt.o : cp-pt.c $(CONFIG_H) $(CPLUS_TREE_H) cp-decl.h cp-parse.h

# Objectionable C language specific files.

objc-parse.o : objc-parse.c $(CONFIG_H) $(TREE_H) c-lex.h \
   c-tree.h input.h flags.h objc-actions.h
	$(CC) $(CFLAGS) -c objc-parse.c
objc-parse.c : objc-parse.y
	$(BISON) $(BISONFLAGS) objc-parse.y -o objc-parse.c

objc-actions.o : objc-actions.c $(CONFIG_H) $(TREE_H) c-tree.h c-lex.h \
   flags.h objc-actions.h

# A file used by all variants of C.

c-common.o : c-common.c $(CONFIG_H) $(TREE_H) c-tree.h c-lex.h flags.h


# Language-independent files.
dumpvers: dumpvers.c

version.o: version.c
obstack.o: obstack.c

tree.o : tree.c $(CONFIG_H) $(TREE_H) gvarargs.h flags.h function.h
print-tree.o : print-tree.c $(CONFIG_H) $(TREE_H)
stor-layout.o : stor-layout.c $(CONFIG_H) $(TREE_H) function.h
fold-const.o : fold-const.c $(CONFIG_H) $(TREE_H) flags.h 
toplev.o : toplev.c $(CONFIG_H) $(TREE_H) $(RTL_H) flags.h input.h \
 insn-attr.h xcoffout.h

rtl.o : rtl.c $(CONFIG_H) $(RTL_H)

print-rtl.o : print-rtl.c $(CONFIG_H) $(RTL_H)
rtlanal.o : rtlanal.c $(CONFIG_H) $(RTL_H)

varasm.o : varasm.c $(CONFIG_H) $(TREE_H) $(RTL_H) flags.h \
   insn-codes.h expr.h hard-reg-set.h regs.h xcoffout.h
function.o : function.c $(CONFIG_H) $(RTL_H) $(TREE_H) flags.h function.h  \
   insn-flags.h insn-codes.h expr.h regs.h hard-reg-set.h insn-config.h \
   recog.h output.h
stmt.o : stmt.c $(CONFIG_H) $(RTL_H) $(TREE_H) flags.h function.h  \
   insn-flags.h insn-config.h insn-codes.h hard-reg-set.h expr.h loop.h recog.h
expr.o : expr.c $(CONFIG_H) $(RTL_H) $(TREE_H) gvarargs.h flags.h function.h  \
   insn-flags.h insn-codes.h expr.h insn-config.h recog.h output.h typeclass.h
calls.o : calls.c $(CONFIG_H) $(RTL_H) $(TREE_H) flags.h expr.h insn-codes.h \
   insn-flags.h
expmed.o : expmed.c $(CONFIG_H) $(RTL_H) $(TREE_H) flags.h  \
   insn-flags.h insn-config.h insn-codes.h expr.h recog.h real.h
explow.o : explow.c $(CONFIG_H) $(RTL_H) $(TREE_H) flags.h hard-reg-set.h \
   insn-config.h expr.h recog.h insn-flags.h insn-codes.h
optabs.o : optabs.c $(CONFIG_H) $(RTL_H) $(TREE_H) flags.h  \
   insn-flags.h insn-config.h insn-codes.h expr.h recog.h
dbxout.o : dbxout.c $(CONFIG_H) $(TREE_H) $(RTL_H) flags.h regs.h \
   insn-config.h reload.h gstab.h xcoffout.h
sdbout.o : sdbout.c $(CONFIG_H) $(TREE_H) $(RTL_H) gsyms.h flags.h \
   insn-config.h reload.h
dwarfout.o : dwarfout.c $(CONFIG_H) $(TREE_H) $(RTL_H) dwarf.h flags.h \
   insn-config.h reload.h output.h
xcoffout.o : xcoffout.c $(CONFIG_H) $(TREE_H) $(RTL_H) xcoffout.h flags.h
emit-rtl.o : emit-rtl.c $(CONFIG_H) $(RTL_H) flags.h gvarargs.h function.h  \
   regs.h insn-config.h insn-codes.h real.h expr.h
real.o : real.c $(CONFIG_H) $(TREE_H)
getpwd.o : getpwd.c $(CONFIG_H)

integrate.o : integrate.c $(CONFIG_H) $(RTL_H) $(TREE_H) flags.h integrate.h \
   insn-flags.h insn-config.h insn-codes.h expr.h real.h function.h

jump.o : jump.c $(CONFIG_H) $(RTL_H) flags.h hard-reg-set.h regs.h \
   insn-config.h insn-flags.h insn-codes.h expr.h real.h
stupid.o : stupid.c $(CONFIG_H) $(RTL_H) regs.h hard-reg-set.h flags.h

cse.o : cse.c $(CONFIG_H) $(RTL_H) regs.h hard-reg-set.h flags.h real.h \
   insn-config.h recog.h
loop.o : loop.c $(CONFIG_H) $(RTL_H) flags.h loop.h insn-config.h \
   insn-flags.h insn-codes.h regs.h hard-reg-set.h recog.h expr.h real.h
unroll.o : unroll.c $(CONFIG_H) $(RTL_H) insn-config.h insn-codes.h \
   integrate.h regs.h flags.h expr.h loop.h
flow.o : flow.c $(CONFIG_H) $(RTL_H) flags.h insn-config.h \
   basic-block.h regs.h hard-reg-set.h output.h
combine.o : combine.c $(CONFIG_H) $(RTL_H) gvarargs.h flags.h  \
   insn-config.h insn-flags.h insn-codes.h insn-attr.h regs.h expr.h \
   basic-block.h recog.h real.h
regclass.o : regclass.c $(CONFIG_H) $(RTL_H) hard-reg-set.h flags.h \
   basic-block.h regs.h insn-config.h recog.h 
local-alloc.o : local-alloc.c $(CONFIG_H) $(RTL_H) flags.h basic-block.h \
   regs.h hard-reg-set.h insn-config.h recog.h output.h
global.o : global.c $(CONFIG_H) $(RTL_H) flags.h  \
   basic-block.h regs.h hard-reg-set.h insn-config.h output.h

reload.o : reload.c $(CONFIG_H) $(RTL_H) flags.h \
   reload.h recog.h hard-reg-set.h insn-config.h insn-codes.h regs.h real.h
reload1.o : reload1.c $(CONFIG_H) $(RTL_H) flags.h expr.h \
   reload.h regs.h hard-reg-set.h insn-config.h insn-flags.h insn-codes.h \
   basic-block.h recog.h output.h
caller-save.o : caller-save.c $(CONFIG_H) $(RTL_H) flags.h \
   regs.h hard-reg-set.h insn-config.h basic-block.h recog.h reload.h expr.h
reorg.o : reorg.c $(CONFIG_H) $(RTL_H) conditions.h hard-reg-set.h \
   basic-block.h regs.h insn-config.h insn-attr.h insn-flags.h recog.h \
   flags.h output.h
sched.o : sched.c $(CONFIG_H) $(RTL_H) basic-block.h regs.h hard-reg-set.h \
   flags.h insn-config.h insn-attr.h
final.o : final.c $(CONFIG_H) $(RTL_H) gvarargs.h flags.h regs.h \
   recog.h conditions.h insn-config.h insn-attr.h real.h output.h \
   hard-reg-set.h insn-codes.h gstab.h xcoffout.h
recog.o : recog.c $(CONFIG_H) $(RTL_H)  \
   regs.h recog.h hard-reg-set.h flags.h insn-config.h insn-attr.h \
   insn-flags.h insn-codes.h real.h
reg-stack.o : reg-stack.c $(CONFIG_H) $(RTL_H) $(TREE_H) \
   regs.h hard-reg-set.h flags.h insn-config.h
   
aux-output.o : aux-output.c $(CONFIG_H) \
   $(RTL_H) regs.h hard-reg-set.h real.h insn-config.h conditions.h \
   insn-flags.h output.h insn-attr.h insn-codes.h

# Now the source files that are generated from the machine description.

.PRECIOUS: insn-config.h insn-flags.h insn-codes.h \
  insn-emit.c insn-recog.c insn-extract.c insn-output.c insn-peep.c \
  insn-attr.h insn-attrtab.c

insn-config.h : md genconfig
	./genconfig md > tmp-insn-config.h
	./move-if-change tmp-insn-config.h insn-config.h

insn-flags.h : md genflags
	./genflags md > tmp-insn-flags.h
	./move-if-change tmp-insn-flags.h insn-flags.h

insn-codes.h : md gencodes
	./gencodes md > tmp-insn-codes.h
	./move-if-change tmp-insn-codes.h insn-codes.h

insn-emit.o : insn-emit.c $(CONFIG_H) $(RTL_H) expr.h insn-config.h
	$(CC) $(CFLAGS) -c insn-emit.c

insn-emit.c : md genemit
	./genemit md > tmp-insn-emit.c
	./move-if-change tmp-insn-emit.c insn-emit.c

insn-recog.o : insn-recog.c $(CONFIG_H) $(RTL_H) insn-config.h
	$(CC) $(CFLAGS) -c insn-recog.c

insn-recog.c : md genrecog
	./genrecog md > tmp-insn-recog.c
	./move-if-change tmp-insn-recog.c insn-recog.c

insn-opinit.o : insn-opinit.c $(CONFIG_H) $(RTL_H) insn-codes.h insn-flags.h \
  insn-config.h flags.h rtl.h recog.h expr.h reload.h
	$(CC) $(CFLAGS) -c insn-opinit.c

insn-opinit.c: md genopinit
	./genopinit md > tmp-opinit.c
	./move-if-change tmp-opinit.c insn-opinit.c

insn-extract.o : insn-extract.c $(RTL_H)
	$(CC) $(CFLAGS) -c insn-extract.c

insn-extract.c : md genextract
	./genextract md > tmp-insn-extract.c
	./move-if-change tmp-insn-extract.c insn-extract.c

insn-peep.o : insn-peep.c $(CONFIG_H) $(RTL_H) regs.h
	$(CC) $(CFLAGS) -c insn-peep.c

insn-peep.c : md genpeep
	./genpeep md > tmp-insn-peep.c
	./move-if-change tmp-insn-peep.c insn-peep.c

insn-output.o : insn-output.c $(CONFIG_H) $(RTL_H) regs.h insn-config.h insn-flags.h conditions.h output.h aux-output.c
	$(CC) $(CFLAGS) -c insn-output.c

insn-output.c : md genoutput
	./genoutput md > tmp-insn-output.c
	./move-if-change tmp-insn-output.c insn-output.c

insn-attrtab.o : insn-attrtab.c $(CONFIG_H) $(RTL_H) regs.h real.h output.h \
     insn-attr.h insn-config.h
	$(CC) $(CFLAGS) -c insn-attrtab.c

insn-attr.h: md genattr
	./genattr md > tmp-attr.h
	./move-if-change tmp-attr.h insn-attr.h

insn-attrtab.c: md genattrtab
	./genattrtab md > tmp-attrtab.c
	./move-if-change tmp-attrtab.c insn-attrtab.c


# Now the programs that generate those files.

genconfig : genconfig.oo rtl.oo $(LIBDEPS1)
	$(HOSTCC) $(HOSTCFLAGS) $(HOSTLDFLAGS) -o genconfig genconfig.oo rtl.oo $(LIBS1)

genconfig.oo : genconfig.c $(RTL_H)
	$(HOSTCC) $(HOSTCFLAGS) -c genconfig.c -o genconfig.oo

genflags : genflags.oo rtl.oo $(LIBDEPS1)
	$(HOSTCC) $(HOSTCFLAGS) $(HOSTLDFLAGS) -o genflags genflags.oo rtl.oo $(LIBS1)

genflags.oo : genflags.c $(RTL_H)
	$(HOSTCC) $(HOSTCFLAGS) -c genflags.c -o genflags.oo

gencodes : gencodes.oo rtl.oo $(LIBDEPS1)
	$(HOSTCC) $(HOSTCFLAGS) $(HOSTLDFLAGS) -o gencodes gencodes.oo rtl.oo $(LIBS1)

gencodes.oo : gencodes.c $(RTL_H)
	$(HOSTCC) $(HOSTCFLAGS) -c gencodes.c -o gencodes.oo

genemit : genemit.oo rtl.oo $(LIBDEPS1)
	$(HOSTCC) $(HOSTCFLAGS) $(HOSTLDFLAGS) -o genemit genemit.oo rtl.oo $(LIBS1)

genemit.oo : genemit.c $(RTL_H)
	$(HOSTCC) $(HOSTCFLAGS) -c genemit.c -o genemit.oo

genopinit : genopinit.oo rtl.oo $(LIBDEPS1)
	$(HOSTCC) $(HOSTCFLAGS) $(HOSTLDFLAGS) -o genopinit genopinit.oo rtl.oo $(LIBS1)

genopinit.oo : genopinit.c $(RTL_H)
	$(HOSTCC) $(HOSTCFLAGS) -c genopinit.c -o genopinit.oo

genrecog : genrecog.oo rtl.oo $(LIBDEPS1)
	$(HOSTCC) $(HOSTCFLAGS) $(HOSTLDFLAGS) -o genrecog genrecog.oo rtl.oo $(LIBS1)

genrecog.oo : genrecog.c $(RTL_H)
	$(HOSTCC) $(HOSTCFLAGS) -c genrecog.c -o genrecog.oo

genextract : genextract.oo rtl.oo $(LIBDEPS1)
	$(HOSTCC) $(HOSTCFLAGS) $(HOSTLDFLAGS) -o genextract genextract.oo rtl.oo $(LIBS1)

genextract.oo : genextract.c $(RTL_H)
	$(HOSTCC) $(HOSTCFLAGS) -c genextract.c -o genextract.oo

genpeep : genpeep.oo rtl.oo $(LIBDEPS1)
	$(HOSTCC) $(HOSTCFLAGS) $(HOSTLDFLAGS) -o genpeep genpeep.oo rtl.oo $(LIBS1)

genpeep.oo : genpeep.c $(RTL_H)
	$(HOSTCC) $(HOSTCFLAGS) -c genpeep.c -o genpeep.oo

genoutput : genoutput.oo rtl.oo $(LIBDEPS1)
	$(HOSTCC) $(HOSTCFLAGS) $(HOSTLDFLAGS) -o genoutput genoutput.oo rtl.oo $(LIBS1)

genoutput.oo : genoutput.c $(RTL_H)
	$(HOSTCC) $(HOSTCFLAGS) -c genoutput.c -o genoutput.oo

genattr : genattr.oo rtl.oo $(LIBDEPS1)
	$(HOSTCC) $(HOSTCFLAGS) $(HOSTLDFLAGS) -o genattr \
	 genattr.oo rtl.oo $(LIBS1)

genattr.oo : genattr.c $(RTL_H) config.h
	$(HOSTCC) -c $(HOSTCFLAGS) genattr.c -o genattr.oo

genattrtab : genattrtab.oo rtl.oo rtlanal.oo $(LIBDEPS1)
	$(HOSTCC) $(HOSTCFLAGS) $(HOSTLDFLAGS) -o genattrtab \
	 genattrtab.oo rtl.oo rtlanal.oo $(LIBS1)

genattrtab.oo : genattrtab.c $(RTL_H) config.h insn-config.h
	$(HOSTCC) -c $(HOSTCFLAGS) genattrtab.c -o genattrtab.oo

rtl.oo : rtl.c $(CONFIG_H) $(RTL_H)
	$(HOSTCC) $(HOSTCFLAGS) -c rtl.c -o rtl.oo

rtlanal.oo : rtlanal.c $(CONFIG_H) $(RTL_H)
	$(HOSTCC) $(HOSTCFLAGS) -c rtlanal.c -o rtlanal.oo

obstack.oo : obstack.c
	$(HOSTCC) $(HOSTCFLAGS) -c obstack.c -o obstack.oo

# Making the preprocessor
gcc-cpp.ttp: cccp
	-rm -f gcc-cpp.ttp
	ln cccp gcc-cpp.ttp

cccp: cccp.o cexp.o version.o $(LIBDEPS)
	$(CC) $(CFLAGS) $(LDFLAGS) -o cccp cccp.o cexp.o version.o $(LIBS)
cexp.o: cexp.c
cexp.c: cexp.y
	$(BISON) cexp.y
	mv cexp.tab.c cexp.c
cccp.o: cccp.c

# gnulib is not deleted because deleting it would be inconvenient
# for most uses of this target.
clean:
	-rm -f *.o *.oo $(STAGESTUFF)
	-rm -f *.s *.s[0-9] *.co *.greg *.lreg *.combine *.flow *.cse *.jump *.rtl *.tree *.loop

# Get rid of every file that's generated from some other file (except INSTALL).
realclean: clean
	-rm -f $(ALL)
	-rm -f cpp.aux cpp.cps cpp.fns cpp.info cpp.kys cpp.pgs cpp.tps cpp.vrs
	-rm -f errs gnulib TAGS 
	-rm -f core report
	-rm -f internals internals-* internals.?? internals.??s

# Copy the files into directories where they will be run.
#install: all
#	install cc1 $(libdir)/gcc-cc1
#	install cpp $(libdir)/gcc-cpp
#	install gcc $(bindir)

force:

#In GNU Make, ignore whether `stage*' exists.
.PHONY: clean realclean
